package com.zoro.mutiDb.conf;

import com.alibaba.druid.pool.DruidDataSource;
import com.alibaba.druid.spring.boot.autoconfigure.DruidDataSourceBuilder;
import org.apache.ibatis.logging.stdout.StdOutImpl;
import org.apache.ibatis.session.SqlSession;
import org.apache.ibatis.session.SqlSessionFactory;
import org.mybatis.spring.SqlSessionFactoryBean;
import org.mybatis.spring.annotation.MapperScan;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.boot.jdbc.DataSourceBuilder;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.Primary;

import javax.sql.DataSource;
import java.util.HashMap;
import org.springframework.core.io.support.PathMatchingResourcePatternResolver;

@Configuration
@MapperScan(basePackages = "com.zoro.mutiDb.mapper.dm",sqlSessionFactoryRef = "dmSqlSessionFactory")
public class DataSourceDmConfig {
//    @Value("${spring.datasource.druid.master1.url}")
//    private String urlO;
//    @Value("${spring.datasource.druid.master2.url}")
//    private String urlD;
//    @Value("${spring.datasource.druid.master1.username}")
//    private String usernameO;
//    @Value("${spring.datasource.druid.master2.username}")
//    private String usernameD;
//    @Value("${spring.datasource.druid.master1.password}")
//    private String passwordO;
//    @Value("${spring.datasource.druid.master2.password}")
//    private String passwordD;
//    @Value("${spring.datasource.druid.master1.driver-class-name}")
//    private String driverO;
//    @Value("${spring.datasource.druid.master2.driver-class-name}")
//    private String driverD;

    @Bean
    @ConfigurationProperties(prefix = "spring.datasource.druid.master2")
    public DataSource dMDataSource() {
        return DruidDataSourceBuilder.create().build();
    }

    @Bean
    //@Primary
    public SqlSessionFactory dmSqlSessionFactory(@Qualifier("dMDataSource") DataSource dataSource)
        throws Exception {
        final SqlSessionFactoryBean dmSqlSessionFactory = new SqlSessionFactoryBean();
        dmSqlSessionFactory.setDataSource(dataSource);
        dmSqlSessionFactory.setMapperLocations(new PathMatchingResourcePatternResolver().getResources("classpath:mapper/dm/*.xml"));
        org.apache.ibatis.session.Configuration configuration = new org.apache.ibatis.session.Configuration();
        configuration.setLogImpl(StdOutImpl.class);
        dmSqlSessionFactory.setConfiguration(configuration);
        return dmSqlSessionFactory.getObject();
    }
}
