package com.zoro.mutiDb.conf;

import com.alibaba.druid.spring.boot.autoconfigure.DruidDataSourceBuilder;
import org.apache.ibatis.logging.stdout.StdOutImpl;
import org.apache.ibatis.session.SqlSessionFactory;
import org.mybatis.spring.SqlSessionFactoryBean;
import org.mybatis.spring.annotation.MapperScan;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.Primary;
import org.springframework.core.io.support.PathMatchingResourcePatternResolver;

import javax.sql.DataSource;

@Configuration
@MapperScan(basePackages = "com.zoro.mutiDb.mapper.mysql",sqlSessionFactoryRef = "mysqlSqlSessionFactory")
public class DataSourceMySqlConfig {
    @Bean
    @ConfigurationProperties(prefix = "spring.datasource.druid.master3")
    public DataSource mySqlDataSource() {
        return DruidDataSourceBuilder.create().build();
    }


    @Bean
    @Primary
    public SqlSessionFactory mysqlSqlSessionFactory(@Qualifier("mySqlDataSource") DataSource dataSource)
            throws Exception {
        final SqlSessionFactoryBean dmSqlSessionFactory = new SqlSessionFactoryBean();
        dmSqlSessionFactory.setDataSource(dataSource);
        dmSqlSessionFactory.setMapperLocations(new PathMatchingResourcePatternResolver().getResources("classpath:mapper/mysql/*.xml"));
        org.apache.ibatis.session.Configuration configuration = new org.apache.ibatis.session.Configuration();
        configuration.setLogImpl(StdOutImpl.class);
        dmSqlSessionFactory.setConfiguration(configuration);
        return dmSqlSessionFactory.getObject();
    }
}
