package com.zoro.mutiDb.conf;

import com.alibaba.druid.spring.boot.autoconfigure.DruidDataSourceBuilder;
import javax.sql.DataSource;
import org.apache.ibatis.logging.stdout.StdOutImpl;
import org.apache.ibatis.session.SqlSessionFactory;
import org.mybatis.spring.SqlSessionFactoryBean;
import org.mybatis.spring.annotation.MapperScan;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.Primary;
import org.springframework.core.io.support.PathMatchingResourcePatternResolver;

/**
 * @ClassName: DataSourceOracleConfig
 * @description: TODO
 * @author: sbj
 * @time: 2023/12/6 9:39
 * @Version: 1.0
 */
@Configuration
@MapperScan(basePackages = "com.zoro.mutiDb.mapper.oracle",sqlSessionFactoryRef = "oracleSqlSessionFactory")
public class DataSourceOracleConfig {

  @Bean
  @ConfigurationProperties(prefix = "spring.datasource.druid.master1")
  public DataSource oracleDataSource() {
    return DruidDataSourceBuilder.create().build();
  }


  @Bean
  //@Primary
  public SqlSessionFactory oracleSqlSessionFactory(@Qualifier("oracleDataSource") DataSource dataSource)
      throws Exception {
    final SqlSessionFactoryBean dmSqlSessionFactory = new SqlSessionFactoryBean();
    dmSqlSessionFactory.setDataSource(dataSource);
    dmSqlSessionFactory.setMapperLocations(new PathMatchingResourcePatternResolver().getResources("classpath:mapper/oracle/*.xml"));
    org.apache.ibatis.session.Configuration configuration = new org.apache.ibatis.session.Configuration();
    configuration.setLogImpl(StdOutImpl.class);
    dmSqlSessionFactory.setConfiguration(configuration);
    return dmSqlSessionFactory.getObject();
  }

}
