package com.zoro.mutiDb.domain.oracle;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import java.time.LocalDate;
import java.time.LocalDateTime;
import lombok.Data;

/**
 * 自维护企业表单
 * @TableName HY_CRET_INFO_SELF
 */
@TableName(value ="HY_CRET_INFO_SELF")
@Data
public class HyCretInfoSelf implements Serializable {
    /**
     * 
     */
    @TableField(value = "CODE")
    private String code;

    /**
     * 证书类型
     */
    @TableField(value = "CRET_TYPE")
    private String cretType;

    /**
     * 发证机关
     */
    @TableField(value = "FZJG")
    private String fzjg;

    /**
     * 证书编号
     */
    @TableField(value = "CRET_NUMER")
    private String cretNumer;

    /**
     * 企业名称
     */
    @TableField(value = "CNAME")
    private String cname;

    /**
     * 管辖机关
     */
    @TableField(value = "JUDGMENT")
    private String judgment;

    /**
     * 经营类型
     */
    @TableField(value = "BUSINESS_TYPE")
    private String businessType;

    /**
     * 备注
     */
    @TableField(value = "BZ")
    private String bz;

    /**
     * 
     */
    @TableField(value = "CRE_DATE")
    private LocalDate creDate;

    /**
     * 证照有效开始日期
     */
    @TableField(value = "EFFECTIVESTARTDATE")
    private LocalDate effectivestartdate;

    /**
     * 证照有效结束日期
     */
    @TableField(value = "EFFECTIVEENDDATE")
    private LocalDate effectiveenddate;

    /**
     * 统一社会信用代码
     */
    @TableField(value = "TAXLICENSE")
    private String taxlicense;

    /**
     * 0失效，1有效
     */
    @TableField(value = "IS_REMOVE")
    private Long isRemove;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;

    @Override
    public boolean equals(Object that) {
        if (this == that) {
            return true;
        }
        if (that == null) {
            return false;
        }
        if (getClass() != that.getClass()) {
            return false;
        }
        HyCretInfoSelf other = (HyCretInfoSelf) that;
        return (this.getCode() == null ? other.getCode() == null : this.getCode().equals(other.getCode()))
            && (this.getCretType() == null ? other.getCretType() == null : this.getCretType().equals(other.getCretType()))
            && (this.getFzjg() == null ? other.getFzjg() == null : this.getFzjg().equals(other.getFzjg()))
            && (this.getCretNumer() == null ? other.getCretNumer() == null : this.getCretNumer().equals(other.getCretNumer()))
            && (this.getCname() == null ? other.getCname() == null : this.getCname().equals(other.getCname()))
            && (this.getJudgment() == null ? other.getJudgment() == null : this.getJudgment().equals(other.getJudgment()))
            && (this.getBusinessType() == null ? other.getBusinessType() == null : this.getBusinessType().equals(other.getBusinessType()))
            && (this.getBz() == null ? other.getBz() == null : this.getBz().equals(other.getBz()))
            && (this.getCreDate() == null ? other.getCreDate() == null : this.getCreDate().equals(other.getCreDate()))
            && (this.getEffectivestartdate() == null ? other.getEffectivestartdate() == null : this.getEffectivestartdate().equals(other.getEffectivestartdate()))
            && (this.getEffectiveenddate() == null ? other.getEffectiveenddate() == null : this.getEffectiveenddate().equals(other.getEffectiveenddate()))
            && (this.getTaxlicense() == null ? other.getTaxlicense() == null : this.getTaxlicense().equals(other.getTaxlicense()))
            && (this.getIsRemove() == null ? other.getIsRemove() == null : this.getIsRemove().equals(other.getIsRemove()));
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((getCode() == null) ? 0 : getCode().hashCode());
        result = prime * result + ((getCretType() == null) ? 0 : getCretType().hashCode());
        result = prime * result + ((getFzjg() == null) ? 0 : getFzjg().hashCode());
        result = prime * result + ((getCretNumer() == null) ? 0 : getCretNumer().hashCode());
        result = prime * result + ((getCname() == null) ? 0 : getCname().hashCode());
        result = prime * result + ((getJudgment() == null) ? 0 : getJudgment().hashCode());
        result = prime * result + ((getBusinessType() == null) ? 0 : getBusinessType().hashCode());
        result = prime * result + ((getBz() == null) ? 0 : getBz().hashCode());
        result = prime * result + ((getCreDate() == null) ? 0 : getCreDate().hashCode());
        result = prime * result + ((getEffectivestartdate() == null) ? 0 : getEffectivestartdate().hashCode());
        result = prime * result + ((getEffectiveenddate() == null) ? 0 : getEffectiveenddate().hashCode());
        result = prime * result + ((getTaxlicense() == null) ? 0 : getTaxlicense().hashCode());
        result = prime * result + ((getIsRemove() == null) ? 0 : getIsRemove().hashCode());
        return result;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", code=").append(code);
        sb.append(", cretType=").append(cretType);
        sb.append(", fzjg=").append(fzjg);
        sb.append(", cretNumer=").append(cretNumer);
        sb.append(", cname=").append(cname);
        sb.append(", judgment=").append(judgment);
        sb.append(", businessType=").append(businessType);
        sb.append(", bz=").append(bz);
        sb.append(", creDate=").append(creDate);
        sb.append(", effectivestartdate=").append(effectivestartdate);
        sb.append(", effectiveenddate=").append(effectiveenddate);
        sb.append(", taxlicense=").append(taxlicense);
        sb.append(", isRemove=").append(isRemove);
        sb.append(", serialVersionUID=").append(serialVersionUID);
        sb.append("]");
        return sb.toString();
    }
}